
function getSpherePosition(animation, sphereI)
{
    var array = [0,0,0];
    var time = getSceneTimeFromStart()*3;

    if (sphereI == 1)
    {
        array[0] = Math.cos(time)*0.5+0.2;
        array[1] = Math.sin(time)*0.8+0.3;
        array[2] = Math.sin(time)*0.5;
    }
    else if (sphereI == 2)
    {
        array[0] = Math.sin(time)*0.5-0.5;
        array[1] = Math.cos(time)*0.5-0.25;
        array[2] = Math.sin(time)+0.5;
    }
    else if (sphereI == 3)
    {
        array[0] = Math.cos(time)*0.5-0.5;
        array[1] = Math.sin(time)*0.7-0.25;
        array[2] = Math.cos(time)*0.6+0.3;
    }
    else if (sphereI == 4)
    {
        array[0] = Math.cos(time)*0.8;
        array[1] = Math.sin(time)*0.4;
        array[2] = Math.cos(time)*0.8;
    }
    else if (sphereI == 5)
    {
        array[0] = Math.sin(time)*0.9;
        array[1] = Math.sin(time)*0.9;
        array[2] = Math.sin(time)*0.2;
    }

    return array;
}

function getSphereMasterScale(animation)
{
    var progress = Utils.calculateProgress(animation.start+animation.sphereStart, animation.sphereFade);
    if (progress >= 1.0)
    {
        progress = 1 - Utils.calculateProgress(animation.start+animation.sphereStart+animation.sphereDuration, animation.sphereFade);
    }
    return progress;
}

var vaporPalette = [
    {"r":0xfa,"g":0x6b,"b":0xff},
    {"r":0x74,"g":0xff,"b":0xde},
    {"r":0xae,"g":0x3c,"b":0xd7},
    {"r":0x63,"g":0x20,"b":0x7b},
    {"r":0x42,"g":0xef,"b":0x9a}
];

var tunnelLineMesh = void null;
function initTunnel(animation) {
    tunnelLineMesh = meshNew();
    if (tunnelLineMesh.ptr === void null) {
        loggerFatal("Could not initialize Mesh");
    }

    var precision = 24;

    //glLineWidth(10);
    var lineMax = 480;
    meshSetFaceDrawType(tunnelLineMesh.ptr, LINES);
    for(var i = 0; i < lineMax; i++) {
        var x = i;
        var y = i;
        var z = -10

        //meshAddVertex(tunnelLineMesh.ptr, x, y, z);
        //meshAddVertex(tunnelLineMesh.ptr, x+1, y+1, z);
    }

    for(var y = 0; y < 100; y+=0.2) {
        for(var x = 0; x < 100; x+=0.2) {
            var z = 0;
            meshAddVertex(tunnelLineMesh.ptr, x, y, z);
            meshAddVertex(tunnelLineMesh.ptr, x, y + 1, z);
            meshAddVertex(tunnelLineMesh.ptr, x, y, z);
            meshAddVertex(tunnelLineMesh.ptr, x + 1, y, z);
        }
    }

    /*for(var i = 0; i < lineMax; i++) {
        var x = Math.cos(i/100*22)*2;
        var y = Math.sin(i/100*20)*2;
        var z = -i
        meshAddVertex(tunnelLineMesh.ptr, x,y,z);
    }
    for(var i = 0; i < lineMax; i++) {
        var x = Math.sin(i/100*20)*2;
        var y = Math.cos(i/100*10)*2;
        var z = -i
        meshAddVertex(tunnelLineMesh.ptr, x,y,z);
    }
    for(var i = 0; i < lineMax; i++) {
        var x = Math.sin(i/100*15)*2;
        var y = Math.cos(i/100*30)*2;
        var z = -i
        meshAddVertex(tunnelLineMesh.ptr, x,y,z);
    }
    for(var i = 0; i < lineMax; i++) {
        var x = Math.sin(i/100*10)*3;
        var y = Math.cos(i/100*10)*3;
        var z = -i
        meshAddVertex(tunnelLineMesh.ptr, x,y,z);
    }*/
    meshGenerate(tunnelLineMesh.ptr);

}

function deinitTunnel(animation) {
    meshDelete(tunnelLineMesh.ptr);
}

function drawTunnel(animation) {
    glPushMatrix();
    perspective2dEnd();
        
    //glTranslatef(0,0,-200 * ((getSceneStartTime()/animation.duration)));
    //glTranslatef(0,0,-0);
    glTranslatef(-5,-5,-5 + 20 * getSceneTimeFromStart()*0.5);
    //glRotatef(getSceneTimeFromStart()*20,0,0,1);
    //glColor4f(1,1,1,(1+Math.sin(getSceneTimeFromStart()*70))/2)
    meshDraw(tunnelLineMesh.ptr);

    glPopMatrix();
}

var chinaLetterData = [];
function initChinaLetters(animation) {
    chinaLetterData = [imageLoadImage("letter1.png"),imageLoadImage("letter2.png"),imageLoadImage("letter3.png")]
}

function drawChinaLetters(animation) {
    var time = getSceneTimeFromStart() * 15.0;
    var index = Math.floor(time % chinaLetterData.length);
    var img = chinaLetterData[index].ptr;
    setTextureScale(img, 3.0, 3.0);
    var chinaLetterVaporColor = vaporPalette[Math.floor(time % vaporPalette.length)];
    setTextureColor(img, chinaLetterVaporColor.r, chinaLetterVaporColor.g, chinaLetterVaporColor.b, 255);
    drawTexture(img);
}

var statueFaceData = [];
var headBg;
var statueFaceRandoms = new Array(60);
var lastRandomize = -10;
function initStatueFaces(animation) {
    headBg = imageLoadImage("head_bg.png");
    statueFaceData = [
        imageLoadImage("head01.png")
        ,imageLoadImage("head02.png")
        ,imageLoadImage("head03.png")
        ,imageLoadImage("head04.png")
        ,imageLoadImage("head05.png")
    ]

    randomizeStatueFaces();
}

function randomizeStatueFaces() {
    if (Math.abs(lastRandomize - (getSceneTimeFromStart())) > timerGetBeatInSeconds() * 2) {
        for (var i = 0; i < 60; i++) {
            statueFaceRandoms[i] = Math.random();
        }
        lastRandomize = getSceneTimeFromStart();
    }
}
function drawStatueFaces(animation) {
    randomizeStatueFaces();
    var yRefine = 50;
    var randI = 0;
    for(var x = 0; x < 6; x++) {
        var scale = 0.8;
        var w = 400 * scale;
        var h = 400 * scale;
        for(var y = 0; y < 3; y++) {
            randI++;
            vaporColor = vaporPalette[Math.floor(statueFaceRandoms[randI] * vaporPalette.length)];
            var img = headBg.ptr;
            setTextureScale(img, scale, scale);
            setTextureColor(img, vaporColor.r, vaporColor.g, vaporColor.b, 255);
            setTexturePosition(img, getScreenWidth()/w+w/2.0+x*w, getScreenHeight()/h+h/2.0+y*h + yRefine, 0);
            drawTexture(img);

            randI++;
            vaporColor = vaporPalette[Math.floor(statueFaceRandoms[randI] * vaporPalette.length)];
            var mirror = Math.random() - 0.5 < 0 ? -1 : 1;
            randI++;
            var img = statueFaceData[Math.floor(statueFaceRandoms[randI] * statueFaceData.length)].ptr;
            setTextureScale(img, scale, scale);
            setTextureColor(img, vaporColor.r, vaporColor.g, vaporColor.b, 255);
            setTexturePosition(img, getScreenWidth()/w+w/2.0+x*w, getScreenHeight()/h+h/2.0+y*h + yRefine, 0);
            drawTexture(img);
        }
    }
}


var fboSceneNameList = ["HeightMap","LutFun","StatueFaces","ManseVice","ChinaLetters","Kiina","MarchinCubes","JmlFist3d","Dkd3d","Statue3d"];
var fboSceneDataList = [];

function initMixer(animation) {
    for (var i = 0; i < fboSceneNameList.length; i++) {
        fboSceneDataList.push(imageLoadImage(fboSceneNameList[i] + "SceneFbo.color.fbo"));
    }
}

function drawMixer(animation) {
    var scene1 = Math.floor(Sync.getSyncValue('scene1'));
    if (scene1 >= 0) {
        var image = fboSceneDataList[scene1];
        setTextureColor(image.ptr, 0xFF,0xFF,0xFF,Sync.getSyncValue('scene1_alpha') * 0xFF);
        drawTexture(image.ptr);
    }

    var scene2 = Math.floor(Sync.getSyncValue('scene2'));
    if (scene2 >= 0) {
        var image = fboSceneDataList[scene2];
        setTextureColor(image.ptr, 0xFF,0xFF,0xFF,Sync.getSyncValue('scene2_alpha') * 0xFF);
        drawTexture(image.ptr);
    }

    var scene3 = Math.floor(Sync.getSyncValue('scene3'));
    if (scene3 >= 0) {
        var image = fboSceneDataList[scene3];
        setTextureColor(image.ptr, 0xFF,0xFF,0xFF,Sync.getSyncValue('scene3_alpha') * 0xFF);
        drawTexture(image.ptr);
    }
}

var heightMapMesh = void null;
var heightMapTexture = void null;
function initHeightMap(animation) {
    heightMapMesh = meshNew();
    if (heightMapMesh.ptr === void null) {
        loggerFatal("Could not initialize Mesh");
    }

    var precision = 24;

    heightMapTexture = imageLoadImage("heightmap.png");
    meshMaterialSetTexture(heightMapMesh.ptr, heightMapTexture.ptr, 0);

    //glLineWidth(10);
    var lineMax = 480;
    meshSetFaceDrawType(heightMapMesh.ptr, TRIANGLES);
    //meshSetFaceDrawType(heightMapMesh.ptr, LINES);

    var max = {"y":40.0,"x":40};
    var step = 0.2;
    var uvStep = {"y":step/max.y,"x":step/max.x};
    for(var y = 0; y < max.y; y+=step) {
        for(var x = 0; x < max.x; x+=step) {
            var z = 0;
            var u = x/max.x;
            var v = y/max.y;

            meshAddTexCoord(heightMapMesh.ptr, u, v);
            meshAddVertex(heightMapMesh.ptr, x, y, z);

            meshAddTexCoord(heightMapMesh.ptr, u + uvStep.x, v + uvStep.y);
            meshAddVertex(heightMapMesh.ptr, x + step, y + step, z);

            meshAddTexCoord(heightMapMesh.ptr, u, v + uvStep.y);
            meshAddVertex(heightMapMesh.ptr, x, y + step, z);

            meshAddTexCoord(heightMapMesh.ptr, u, v);
            meshAddVertex(heightMapMesh.ptr, x, y, z);

            meshAddTexCoord(heightMapMesh.ptr, u + uvStep.x, v);
            meshAddVertex(heightMapMesh.ptr, x + step, y, z);

            meshAddTexCoord(heightMapMesh.ptr, u + uvStep.x, v + uvStep.y);
            meshAddVertex(heightMapMesh.ptr, x + step, y + step, z);

            /*meshAddTexCoord(heightMapMesh.ptr, u, v);
            meshAddVertex(heightMapMesh.ptr, x, y, z);

            meshAddTexCoord(heightMapMesh.ptr, u + uvStep, v);
            meshAddVertex(heightMapMesh.ptr, x + step, y, z);

            meshAddTexCoord(heightMapMesh.ptr, u, v + uvStep);
            meshAddVertex(heightMapMesh.ptr, x, y + step, z);

            meshAddTexCoord(heightMapMesh.ptr, u, v);
            meshAddVertex(heightMapMesh.ptr, x, y, z);*/
        }
    }

    meshGenerate(heightMapMesh.ptr);

}

function deinitHeightMap(animation) {
    meshDelete(heightMapMesh.ptr);
    texturedQuadDeinit(heightMapTexture.ptr);
}

function drawHeightMap(animation) {
    glPushMatrix();
    perspective2dEnd();
        
    //glTranslatef(0,0,-200 * ((getSceneStartTime()/animation.duration)));
    //glTranslatef(0,0,-0);
    glTranslatef(-20,-2.1,0);// * getSceneTimeFromStart()*0.5);
    glRotatef(-90,1,0,0);
    //glColor4f(1,1,1,(1+Math.sin(getSceneTimeFromStart()*70))/2)
    meshDraw(heightMapMesh.ptr);

    glPopMatrix();
}

function getPaletteColor(index) {
    if (index == void null || index == -3) {
        index = Utils.getRandomArrayIndex(vaporPalette);
    } else if (index == -1) {
        return [1.0,1.0,1.0,1.0];
    } else if (index == -2) {
        return [0.0,0.0,0.0,1.0];
    }

    var vaporColor = vaporPalette[Math.floor(index)];
    var vaporColor1 = {"r": vaporColor.r, "g":vaporColor.g, "b":vaporColor.b};
    if (index % 1.0 > 0.0) {
        // not really performant...
        vaporColor = vaporPalette[Math.floor(index + 1.0) % vaporPalette.length];
        var vaporColor2 = {"r": vaporColor.r, "g":vaporColor.g, "b":vaporColor.b};

        var percent = index % 1.0;
        vaporColor1.r = Utils.mix(vaporColor1.r, vaporColor2.r, percent);
        vaporColor1.g = Utils.mix(vaporColor1.g, vaporColor2.g, percent);
        vaporColor1.b = Utils.mix(vaporColor1.b, vaporColor2.b, percent);
    }

    return vaporColor1;
}

function getPaletteColorAsUniform(index) {
    var vaporColor = getPaletteColor(index);
    return [vaporColor.r / 255.0, vaporColor.g / 255.0, vaporColor.b / 255.0, 1.0];
}

function getRelativeTimeForTimeline(rocketVar) {
    var value = Sync.getSyncValue(rocketVar);
    if (value < 0) {
        return 0;//getSceneTimeFromStart();
    }

    return 0;
}

Demo.prototype.init = function()
{
    Sync.addSync(
    [
         { "name":"scene1", "type":"rocket" }
        ,{ "name":"scene1_alpha", "type":"rocket" }
        ,{ "name":"scene1_start", "type":"rocket" }
        ,{ "name":"scene2", "type":"rocket" }
        ,{ "name":"scene2_alpha", "type":"rocket" }
        ,{ "name":"scene2_start", "type":"rocket" }
        ,{ "name":"scene3", "type":"rocket" }
        ,{ "name":"scene3_alpha", "type":"rocket" }
        ,{ "name":"scene3_start", "type":"rocket" }
        ,{ "name":"rotX", "type":"rocket" }
        ,{ "name":"rotY", "type":"rocket" }
        ,{ "name":"rotZ", "type":"rocket" }
        ,{ "name":"c1", "type":"rocket" }
        ,{ "name":"c2", "type":"rocket" }
        ,{ "name":"c3", "type":"rocket" }
        ,{ "name":"c4", "type":"rocket" }
        ,{ "name":"c5", "type":"rocket" }
        ,{ "name":"c6", "type":"rocket" }
        ,{ "name":"lut_type", "type":"rocket" }
        ,{ "name":"lut_u", "type":"rocket" }
        ,{ "name":"lut_v", "type":"rocket" }
        ,{ "name":"a_fade", "type":"rocket" }
        ,{ "name":"raymarchScenes", "type":"rocket" }
    ]);

    var vaporColor = vaporPalette[0];
    this.loader.addSceneToTimeline([
        {
            "layer": 1,
            "scene": "{return fboSceneNameList[Sync.getSyncValue('scene1')]; }",
            "start": "{return Sync.getSyncValue('scene1_start'); }",
            "duration": 1000
        },
        {
            "layer": 1,
            "scene": "{return fboSceneNameList[Sync.getSyncValue('scene2')]; }",
            "start": "{return Sync.getSyncValue('scene2_start'); }",
            "duration": 1000
        },
        {
            "layer": 1,
            "scene": "{return fboSceneNameList[Sync.getSyncValue('scene3')]; }",
            "start": "{return Sync.getSyncValue('scene3_start'); }",
            "duration": 1000
        },
        {
            "layer": 100,
            "scene": "Front",
            "start": 0,
            "duration": 1000
        }
        /*
        {
            "layer": 1,
            "scene": "LutFun",
            "start": 0,
            "duration": 10
        },
        {
            "layer": 1,
            "scene": "StatueFaces",
            "start": 0,
            "duration": 1
        },
        {
            "layer": 2,
            "scene": "StatueFaces",
            "start": 2,
            "duration": 1
        },
        {
            "layer": 2,
            "scene": "Kiina",
            "start": 2,
            "duration": 0.5
        }
        ,{
            "layer": 3,
            "scene": "StatueFaces",
            "start": 4,
            "duration": 6
        },
        {
            "layer": 3,
            "scene": "JmlVice",
            "start": 4,
            "duration": 6
        }*/]
    );

    var start = 0;
    var duration = 182;
    var layer = 1; 
/*

return;*/
    /*this.loader.addAnimation([{
         "start": start, "duration": duration
        ,"layer": layer
        ,"initFunction": "{initTunnel(animation);}"
        ,"deinitFunction": "{deinitTunnel(animation);}"
        ,"runFunction": "{drawTunnel(animation);}"
    }]);*/
    /*this.loader.addAnimation([{
         "start": start, "duration": duration
        ,"layer": layer
        ,"initFunction": "{initTunnel2(animation);}"
        ,"deinitFunction": "{deinitTunnel(animation);}"
        ,"runFunction": "{drawTunnel(animation);}"
    }]);
return;*/

    /*this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "gold.png"
        //,"color":[{"a":0},{"duration":1.0,"a":255}]
    });
return;*/
    this.loader.setScene("MarchinCubes");

    this.loader.addAnimation([
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "_embedded/defaultWhite.png"
        ,"sphereStart":0
        ,"sphereFade":1
        ,"sphereDuration":120
        ,"shader":{"name":"raymarching.fs",
            "variable":[
                 {"name":"spherePos1","value":"{return getSpherePosition(animation, 1);}"}
                ,{"name":"spherePos2","value":"{return getSpherePosition(animation, 2);}"}
                ,{"name":"spherePos3","value":"{return getSpherePosition(animation, 3);}"}
                ,{"name":"spherePos4","value":"{return getSpherePosition(animation, 4);}"}
                ,{"name":"spherePos5","value":"{return getSpherePosition(animation, 5);}"}
                ,{"name":"masterScale","value":["{return getSphereMasterScale(animation);}"]}
                ,{"name":"colorBalls","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c5'));}"}
                ,{"name":"raymarchScenes","type":"int","value":["{return Sync.getSyncValue('raymarchScenes');}"]}
            ]
        }
    }]);

    this.loader.setScene("HeightMap");
    /*this.loader.addAnimation(
    { 
         //"start": 0, "duration": 9999, "layer": 0
         //"start": start, "duration": duration, "layer": 0
         "start": 0, "duration": 9999, "layer": 1
        ,"fbo":{"name":"HeightMapFbo","action":"begin"}
    });
    this.loader.addAnimation(
    { 
         //"start": 0, "duration": 9999, "layer": 9999
         "start": 0, "duration": 9999, "layer": 9999
        ,"fbo":{"name":"HeightMapFbo","action":"end"}
    });*/

    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "_embedded/defaultWhite.png"
        ,"shader":{
             "name":"retroBackground.fs"
            ,"variable":[
                 {"name":"colorStart","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c1'));}"}
                ,{"name":"colorEnd","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c2'));}"}
                ,{"name":"colorSunStart","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c3'));}"}
                ,{"name":"colorSunEnd","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c4'));}"}
            ]
         }
    });
    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "jml_fist.png"
        ,"scale":[{"uniform2d":0.55}]
        ,"position":[{"x":getScreenWidth()/2.0,"y":getScreenHeight()*0.72}]
        ,"color":[{"r":vaporColor.r,"g":vaporColor.g,"b":vaporColor.b}]
    });

    this.loader.addAnimation([{
         "start": start, "duration": duration
        ,"layer": layer
        ,"initFunction": "{initHeightMap(animation);}"
        ,"deinitFunction": "{deinitHeightMap(animation);}"
        ,"runFunction": "{drawHeightMap(animation);}"
        ,"shader":{
             "name":["heightmap.vs","heightmap.fs"]
            ,"variable":[
                 {"name":"terrain","type":"int","value":[0]}
                ,{"name":"colorTerrain","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c5'));}"}
                ,{"name":"colorGrid","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c6'));}"}
            ]
        }
    }]);
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "auto_back.png"
        ,"scale":[{"uniform2d":0.17}]
        ,"position":[{"x":"{return getScreenWidth()/2.0+Math.sin(getSceneTimeFromStart())*50;}","y":getScreenHeight()*0.14}]
        ,"angle":[{"degreesZ":"{return Math.sin(getSceneTimeFromStart()*1.2)*4;}"}]
    });

    this.loader.setScene("Front", {"useFbo": false});
    //return;
    this.loader.addAnimation({
         "start": start, "duration": duration, "layer": layer
        ,"initFunction": "{initMixer(animation);}"
        ,"runFunction": "{drawMixer(animation);}"
    });

    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "vignette.png"
        ,"color":[{"a":150}]
    });
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"position":[{"x":getScreenWidth()*0.92, "y":getScreenHeight()*0.9}]
        ,"image": "jml_tv_logo.png"
        ,"scale":[{"uniform2d":0.2}]
        ,"color":[{"a":50}]
    });

    this.loader.setScene("StatueFaces");
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"initFunction": "{initStatueFaces(animation);}"
        ,"runFunction": "{drawStatueFaces(animation);}"
    });


    this.loader.setScene("ChinaLetters");
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"initFunction": "{initChinaLetters(animation);}"
        ,"runFunction": "{drawChinaLetters(animation);}"
    });

    this.loader.setScene("LutFun");
    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "checkerboard.png"
        ,"scale":[{"uniform2d":10.0}]
        ,"shader":{"name":"deformation.fs",
            "variable":[
                 {"name":"effect","type":"int","value":"{return [Sync.getSyncValue('lut_type')];}"}
                ,{"name":"texCoordMultiplier","value":"{return [Sync.getSyncValue('lut_u'), Sync.getSyncValue('lut_v')];}"}
                ,{"name":"colorVapor","value":"{return getPaletteColorAsUniform(Sync.getSyncValue('c5'));}"}
            ]
        }
    });

    this.loader.setScene("ManseVice");

    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "miami_jumalauta_backdrop.png"
        ,"position": [{"x":getScreenWidth()/2.0,"y":getScreenWidth()*0.188}]
        ,"color":[{"r":vaporColor.r,"g":vaporColor.g,"b":vaporColor.b,"a":"{ return Sync.getSyncValue('a_fade')*0xFF; }"}]
    });
    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "miami_jumalauta.png"
        ,"color":[{"r":vaporColor.r,"g":vaporColor.g,"b":vaporColor.b,"a":"{ return Sync.getSyncValue('a_fade')*0xFF; }"}]
    });
    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "miami_jumalauta_backdrop.png"
        ,"position": [{"x":getScreenWidth()/2.0,"y":getScreenWidth()*0.188}]
        ,"scale":[{"x":0.52,"y":1}]
        ,"color":[{"r":vaporColor.r,"g":vaporColor.g,"b":vaporColor.b,"a":"{ return (1-Sync.getSyncValue('a_fade'))*0xFF; }"}]
    });
    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "miami_manse.png"
        ,"scale":[{"uniform2d":0.45}]
        ,"color":[{"r":vaporColor.r,"g":vaporColor.g,"b":vaporColor.b,"a":"{ return (1-Sync.getSyncValue('a_fade'))*0xFF; }"}]
    });
    vaporColor = vaporPalette[Utils.getRandomArrayIndex(vaporPalette)];
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"image": "miami_vice.png"
        ,"position": [{"x":getScreenWidth()/2.0,"y":getScreenWidth()*0.2}]
        ,"scale":[{"uniform2d":0.5}]
        ,"color":[{"r":vaporColor.r,"g":vaporColor.g,"b":vaporColor.b}]
    });

    this.loader.setScene("Statue3d");
    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        //,"object": "statue_smaller_patched.blend"
        ,"object": "statue_smaller_patched.obj"
        ,"scale":[{"uniform3d":0.6}]
        ,"angle":[{"degreesX":-90},{"duration": duration, "degreesZ": -360 * 50}]
        ,"position":[{"y":"{return Sync.getSyncValue('rotY'); }"}]
        /*,"position":[{"z":-50}]*/
        //,"color":[{"a":0},{"duration":1.0,"a":255}]
        //,"color":[{"r":0}]
        //,"position":[{"y":210,"x": 740}]
        //,"angle":[{"degreesZ":"{return Math.sin(getSceneTimeFromStart()*2.0)*360;}"}]
        //,"position":[{"z":-20}]
    });

    this.loader.setScene("Kiina");

    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        //,"object": "statue_smaller_patched.blend"
        ,"object": "kiina.obj"
        ,"scale":[{"uniform3d":0.5}]
        ,"angle":[{"degreesY":"{return Sync.getSyncValue('rotY'); }"}]
        /*,"position":[{"z":-50}]*/
        //,"color":[{"a":0},{"duration":1.0,"a":255}]
        //,"color":[{"r":0}]
        //,"position":[{"y":210,"x": 740}]
        //,"angle":[{"degreesZ":"{return Math.sin(getSceneTimeFromStart()*2.0)*360;}"}]
        //,"position":[{"z":-20}]
    });

    this.loader.setScene("JmlFist3d");

    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"object": "jml_fist_flat.obj"
        ,"scale":[{"uniform2d":0.1}]
        ,"angle":[{"degreesY":"{return Sync.getSyncValue('rotY'); }"}]
        ,"position":[{},{"duration":10,"x":0}]
    });

    this.loader.setScene("Dkd3d");

    this.loader.addAnimation(
    {
         "start": start, "duration": duration, "layer": layer
        ,"object": "dekadence_logo.obj"
        ,"angle":[{"degreesX":-90,"degreesX":"{return Sync.getSyncValue('rotY')-90; }"}]
    });



}
