#version 330 core

/*
jml live voting committee in GLSL:
semifast music compo (name)votes:
1. apinan papana by roz/fit
2. ylvays/jml
=> WINNER
3. dekathlon by juzdie/artline designs
=> WINNER (even though it has wrong group)
4. dkd imee vy player one/dkd
5. the music song by p-kl/jml
=> WINNER

basic demo
1. yleisradio
2. spiikin demo
3. z-basic by zerox
4. happy birthday dekadence by terwiz

halt and catch fire
*/

in vec2 texCoord;
in vec4 vertexFragColor;
out vec4 fragColor;
uniform sampler2D texture0;
uniform vec4 colorRoad = vec4(0.3,0.3,0.3,1);
uniform vec4 colorTerrain = vec4(1,0,0,1);
uniform vec4 colorGrid = vec4(1,0,0,1);
uniform bool enableVertexColor = true;
in float xSpaceFrag;

void main() {
    fragColor = colorRoad;
    vec2 tex = texCoord;

    if (vertexFragColor.r > 0.8) {
        fragColor = vertexFragColor * colorGrid;
    } else if (tex.x-0.5 > xSpaceFrag-0.004 || tex.x-0.5+xSpaceFrag-0.004 < 0) {
        fragColor = (colorTerrain*0.4) + texture(texture0, texCoord)*0.6;
        fragColor.a = 1;
    }

    if (tex.x-0.5 > xSpaceFrag-0.009 && tex.x-0.5 < xSpaceFrag-0.004) {
        fragColor = colorGrid;
    } else if (tex.x-0.5+xSpaceFrag > 0 && tex.x-0.5+xSpaceFrag-0.004 < 0) {
        fragColor = colorGrid;
    } else if (abs(tex.x - 0.5) < xSpaceFrag*0.08 && mod(tex.y*0.7, 0.1) < 0.04) {
        fragColor = colorGrid;
    }
}
